/******************************************************************************
*
* Copyright (C) 2004-2007, The Gentee Group. All rights reserved. 
* This file is part of the Gentee open source project - http://www.gentee.com. 
* 
* THIS FILE IS PROVIDED UNDER THE TERMS OF THE GENTEE LICENSE ("AGREEMENT"). 
* ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS FILE CONSTITUTES RECIPIENTS 
* ACCEPTANCE OF THE AGREEMENT.
*
* ID: vis.dialogs 19.09.07 0.0.A.
*
* Author: Alexander Krivonogov ( gentee )
*
******************************************************************************/


/*  vOpenDialog,   vComp
*/

type vOpenSaveDialog <inherit = vComp> {
//Hidden Fields   
   ustr         pDefExt
   ustr         pInitialDir
   ustr         pFileName
   locustr      pTitleOpen
   locustr      pTitleSave      
   uint         pFilterIndex
   locustr      pFiltersText
   uint         pMultiSelect
   
//Public Fields   
   arrustr      Filters
   arrustr      Files
}

define 
{
   osfMultiSelect = 0x01
//   osfENABLESIZING
}

define
{
   OSD_BUFSIZE = 4096 //     
}

method uint vComp.GetActiveHWND()
{ 
   uint hwnd
   if &.Owner 
   {    
      hwnd = .Owner->vCtrl.GetMainForm()->vCtrl.hwnd         
      if !IsWindowEnabled( hwnd )
      { 
         hwnd = 0     
      }         
   }
   if !hwnd : hwnd = GetActiveWindow()
   return hwnd
}

/*------------------------------------------------------------------------------
   Hidden Methods
*/
method vOpenSaveDialog.iUpdateFilters()
{
   /*uint filtertext = .pFiltersText.Text( this )
   if */
   .Filters.load( .pFiltersText.Text( this ), 0 )
}

/*        */
method uint vOpenSaveDialog.Show( uint flgsave )
{
   OPENFILENAME pOFN
   ustr files   
   buf  bfilters
   files.reserve( $OSD_BUFSIZE )
   if flgsave 
   {
      files =  .pFileName
   } 
   files.use = $OSD_BUFSIZE
   with pOFN
   {      
      .lStructSize = sizeof( OPENFILENAME )
      .lpstrDefExt = this.pDefExt.ptr()
      .lpstrInitialDir = this.pInitialDir.ptr()   
      .lpstrFile = files.ptr()
      
      ustr title
      if flgsave : title = .pTitleSave.Text( this )
      else : title = .pTitleOpen.Text( this )
      if *title : .lpstrTitle = title.ptr()
      
      .nMaxFile = $OSD_BUFSIZE      
      .hwndOwner = .GetActiveHWND()
      .Flags = $OFN_EXPLORER | $OFN_HIDEREADONLY | ?( flgsave, $OFN_OVERWRITEPROMPT, $OFN_FILEMUSTEXIST | $OFN_PATHMUSTEXIST ) | ?( this.pMultiSelect, $OFN_ALLOWMULTISELECT, 0 )
      if *.Filters
      {         
         arrustr arpair         
         foreach pair, .Filters
         {
            pair.split( arpair, '\', 0 )
            if *arpair == 1
            {
               bfilters@arpair[0]
               bfilters@'\h2 0'      
            }
            elif *arpair > 1
            {          
               bfilters@arpair[0]@arpair[1]                  
            }                         
         }
         bfilters@'\h2 0'                  
         .lpstrFilter = bfilters.ptr()
         .nFilterIndex = .pFilterIndex
      }
   }
   uint res = ?( flgsave, GetSaveFileName( pOFN ), GetOpenFileName( pOFN ) )   
   if res
   {
      .Files.clear()  
      if !flgsave & this.pMultiSelect 
      {
         uint start = 0
         while ( files.ptr() + ( start << 1) )->ushort
         {            
               start = files.findsh( start, 0 ) + 1
         }
         files.use = start << 1
         files.getmultiustr( .Files )         
         if *.Files > 1
         {
            ustr dir = .Files[0]            
            
            if dir[*dir-1] != '\'
            {
               dir = dir + "\\".ustr()
            }            
            .Files.del( 0 )                        
            foreach x, .Files
            {
               x = dir + x 
            }   
         }         
      }
      else
      {
         files.setlenptr()         
         .Files.expand(1)
         .Files[0] = files
      }
      
      .pInitialDir = files.str().fgetdir("").ustr()
      .pFileName = .Files[0]  
   }
   return res
}

/*------------------------------------------------------------------------------
   Public Methods
*/
/*     */
method uint vOpenSaveDialog.ShowOpenFile()
{  
   return this.Show( 0 )
}

/*     */
method uint vOpenSaveDialog.ShowSaveFile()
{
   return this.Show( 1 )
}

/*------------------------------------------------------------------------------
   Properties
*/

/*  uint DefExt - Get Set
     
*/
property ustr vOpenSaveDialog.DefExt<result>() 
{
   result = .pDefExt  
}

property vOpenSaveDialog.DefExt( ustr val )
{
   if .pDefExt != val
   {
      .pDefExt = val
   }
}

/*  uint InitialDir - Get Set
    
*/
property ustr vOpenSaveDialog.InitialDir<result>()
{
   result = .pInitialDir  
}

property vOpenSaveDialog.InitialDir( ustr val )
{
   if .pInitialDir != val
   {
      .pInitialDir = val
   }
}


/*  uint InitialDir - Get Set
     
*/
property ustr vOpenSaveDialog.FileName<result>()
{
   result = .pFileName  
}

property vOpenSaveDialog.FileName( ustr val )
{
   if .pFileName != val
   {
      .pFileName = val
   }
}

/*  uint Options - Get Set
   
*/
property uint vOpenSaveDialog.MultiSelect()
{
   return .pMultiSelect
}

property vOpenSaveDialog.MultiSelect( uint val )
{
   if .pMultiSelect != val
   {
      .pMultiSelect = val
   }
}

/*  uint FilterIndex - Get Set
     
*/
property uint vOpenSaveDialog.FilterIndex()
{
   return .pFilterIndex
}

property vOpenSaveDialog.FilterIndex( uint val )
{
   if .pFilterIndex != val
   {
      .pFilterIndex = min( val, *.Filters  )
   }
}

/*  uint TitleOpen - Get Set
      
*/
property ustr vOpenSaveDialog.TitleOpen <result>
{
   result = this.pTitleOpen.Value
}

property vOpenSaveDialog.TitleOpen( ustr val )
{   
   this.pTitleOpen.Value = val       
}

/*  uint TitleSave - Get Set
      
*/
property ustr vOpenSaveDialog.TitleSave <result>
{
   result = this.pTitleSave.Value
}

property vOpenSaveDialog.TitleSave( ustr val )
{   
   this.pTitleSave.Value = val       
}

/*  uint FiltersText - Get Set
      
*/
property ustr vOpenSaveDialog.FiltersText <result>
{
   result = this.pFiltersText.Value
}

property vOpenSaveDialog.FiltersText( ustr val )
{   
   if this.pFiltersText.Value != val
   { 
      this.pFiltersText.Value = val
      .iUpdateFilters()      
   }       
}


/*  uint vOpenSaveDialog.mLangChanged -   
*/
method vOpenSaveDialog.mLangChanged <alias=vOpenSaveDialog_mLangChanged>()
{
   if *this.pFiltersText.Value : .iUpdateFilters()
   this->vComp.mLangChanged() 
}


/*  vOpenDialog,   vComp
*/

type vSelectDir <inherit = vComp> {
//Hidden Fields   
/*   ustr         pDefExt
   ustr         pInitialDir
   ustr         pFileName*/
   ustr         pDir
   locustr      pTitle   
   uint         pCanCreate
   uint         pShowEdit   
}


//--------------------------------------------------------------------------



type BROWSEINFO {
    uint hwndOwner
    uint pidlRoot
    uint pszDisplayName
    uint lpszTitle
    uint ulFlags
    uint lpfn
    uint lParam
    int iImage
} 

import "ole32.dll" {
uint CoTaskMemAlloc( uint )
CoTaskMemFree( uint )
uint CoInitializeEx( uint, uint )
uint CoInitialize(uint)
}

import "shell32.dll" {
uint SHGetSpecialFolderLocationW( uint, int, uint ) -> SHGetSpecialFolderLocationW   
uint SHGetPathFromIDListW( uint, uint ) -> SHGetPathFromIDList
uint SHBrowseForFolderW( BROWSEINFO ) -> SHBrowseForFolder
}

define {
   BIF_RETURNONLYFSDIRS  = 0x0001
   BIF_EDITBOX           = 0x0010   
   BIF_NEWDIALOGSTYLE    = 0x0040
   BIF_NONEWFOLDERBUTTON = 0x0200 
   
   BFFM_INITIALIZED     = 1
   
   BFFM_SETSELECTION    = $WM_USER + 103 //BFFM_SETSELECTIONW
}

global {
   uint AddrBrowseCallbackProc
}


/*------------------------------------------------------------------------------
   Properties
*/

/*  ustr Title - Get Set
      
*/
property ustr vSelectDir.Title<result>() 
{
   result = .pTitle  
}

property vSelectDir.Title( ustr val )
{
   if .pTitle != val
   {
      .pTitle = val
   }
}

/*  ustr Dir - Get Set
     
*/
property ustr vSelectDir.Dir<result>() 
{
   result = .pDir  
}

property vSelectDir.Dir( ustr val )
{
   if .pDir != val
   {
      .pDir = val
   }
}

/*  ustr C - Get Set
     
*/
property uint vSelectDir.CanCreate() 
{
   return .pCanCreate   
}

property vSelectDir.CanCreate( uint val )
{
   if .pCanCreate != val
   {
      .pCanCreate = val
   }
}

/*  ustr C - Get Set
    Edit   
*/
property uint vSelectDir.ShowEdit() 
{
   return .pShowEdit 
}

property vSelectDir.ShowEdit( uint val )
{
   if .pShowEdit != val
   {
      .pShowEdit = val
   }
}


func int BrowseCallbackProc( uint hwnd uMsg lParam lpData ) 
{ 
   if uMsg == $BFFM_INITIALIZED && lpData 
   { 
       SendMessage( hwnd, $BFFM_SETSELECTION, 1, lpData->ustr.ptr() ) 
   } 
   return 0
}

method uint vSelectDir.Show( )
{
 //  int   nidl
   uint  result   
   BROWSEINFO    bi
   uint  lpidl
   uint  pidlRoot = 0

   /*if( nidl )
   {
      SHGetSpecialFolderLocation( owner, nidl, &pidlRoot)
   }*/   
   
   if ( *.pDir )
   {
      bi.lpfn = AddrBrowseCallbackProc 
      bi.lParam = &.pDir
   }
      
   bi.hwndOwner = .GetActiveHWND()
   
   bi.pidlRoot = pidlRoot
   bi.pszDisplayName = 0//"dir".ptr()
   bi.lpszTitle = this.pTitle.Text( this ).ptr()
   bi.ulFlags = $BIF_RETURNONLYFSDIRS | $BIF_NEWDIALOGSTYLE 
   if .pShowEdit : bi.ulFlags |= $BIF_EDITBOX
   if !.pCanCreate : bi.ulFlags |= $BIF_NONEWFOLDERBUTTON 
   //CoInitialize(0)  
   lpidl = SHBrowseForFolder( bi )
   if ( lpidl )
   {
      .pDir.reserve( 260 )
      SHGetPathFromIDList( lpidl, .pDir.ptr() )                
      .pDir.setlenptr()      
      CoTaskMemFree( lpidl )
      result = 1
   }
   else
   {
      .pDir.clear()
   }
   /*
   if(pidlRoot)
   {      
      CoTaskMemFree( pidlRoot )
   }
*/
   return result
}



/*  vColorDialog,   vComp
*/

type vColorDialog <inherit = vComp> {
//Hidden Fields
   uint         pColor     
   arr          CustColors[16] of uint
   uint         pFullOpen
   uint         pPreventFullOpen
   uint         pSolidColor
   uint         pAnyColor
}

/*------------------------------------------------------------------------------
   Properties
*/

/*  uint Color - Get Set
    
*/
property uint vColorDialog.Color() 
{
   return .pColor
}

property vColorDialog.Color( uint val )
{
   if .pColor != val
   {
      .pColor = val
   }
}

/*  uint AnyColor - Get Set
     
*/
property uint vColorDialog.AnyColor() 
{
   return .pAnyColor
}

property vColorDialog.AnyColor( uint val )
{
   if .pAnyColor != val
   {
      .pAnyColor = val
   }
}

/*  uint SolidColor - Get Set
     
*/
property uint vColorDialog.SolidColor() 
{
   return .pSolidColor
}

property vColorDialog.SolidColor( uint val )
{
   if .pSolidColor != val
   {
      .pSolidColor = val
   }
}

/*  ustr FullOpen - Get Set
     
*/
property uint vColorDialog.FullOpen() 
{
   return .pFullOpen
}

property vColorDialog.FullOpen( uint val )
{
   if .pFullOpen != val
   {
      .pFullOpen = val
   }
}

/*  ustr PreventFullOpen - Get Set
     
*/
property uint vColorDialog.PreventFullOpen() 
{
   return .pPreventFullOpen
}

property vColorDialog.PreventFullOpen( uint val )
{
   if .pPreventFullOpen != val
   {
      .pPreventFullOpen = val
   }
}

func uint rgb_bgr( uint src )
{
   return ( (src & 0xFF ) << 16 ) | ( src & 0xFF00 ) | ( ( src & 0xFF0000 ) >> 16 )
}
/*     */
method uint vColorDialog.Show( )
{   
   CHOOSECOLOR chc
   arr         tmpcolors[16] of uint
   tmpcolors = .CustColors
   
   chc.lStructSize = sizeof( CHOOSECOLOR )
   /*if &.Owner
   {         
      chc.hwndOwner = .Owner->vCtrl.GetMainForm()->vCtrl.hwnd         
   }*/
   chc.hwndOwner = .GetActiveHWND()
   chc.rgbResult = rgb_bgr( .pColor ) 
   chc.lpCustColors = tmpcolors.ptr()
   chc.Flags = $CC_RGBINIT
   if .pAnyColor : chc.Flags |= $CC_ANYCOLOR
   if .pSolidColor : chc.Flags |= $CC_SOLIDCOLOR
   if .pFullOpen : chc.Flags |= $CC_FULLOPEN
   if .pPreventFullOpen : chc.Flags |= $CC_PREVENTFULLOPEN
   if ChooseColor( chc )
   {  
      .CustColors = tmpcolors
      .pColor = rgb_bgr( chc.rgbResult )
      return 1
   }
   return 0
}


/*  vFontDialog,   vComp
*/

type vFontDialog <inherit = vComp> {
//Hidden Fields
   LOGFONT  LogFont
   uint     pDevice
   uint     pSizeMin
   uint     pSizeMax   
   uint     pEffects
   uint     pColor     
   
}

define {
   fddScreen = $CF_SCREENFONTS
   fddPrinter = $CF_PRINTERFONTS
   fddBoth = $CF_BOTH
}

operator LOGFONT =( LOGFONT left right )
{
   mcopy( &left, &right, sizeof( LOGFONT ))
   return left
}
/*------------------------------------------------------------------------------
   Properties
*/

/*  uint SizeMin - Get Set
     
*/
property uint vFontDialog.SizeMin() 
{
   return .pSizeMin
}

property vFontDialog.SizeMin( uint val )
{
   if .pSizeMin != val
   {
      .pSizeMin = val
   }
}

/*  uint SizeMax - Get Set
     
*/
property uint vFontDialog.SizeMax() 
{
   return .pSizeMax
}

property vFontDialog.SizeMax( uint val )
{
   if .pSizeMax != val
   {
      .pSizeMax = val
   }
}

/*  uint Device - Get Set
     
*/
property uint vFontDialog.Device() 
{
   return .pDevice
}

property vFontDialog.Device( uint val )
{
   if .pDevice != val
   {
      .pDevice = val
   }
}

/*  uint Effects - Get Set
    
*/
property uint vFontDialog.Effects() 
{
   return .pEffects
}

property vFontDialog.Effects( uint val )
{
   if .pEffects != val
   {
      .pEffects = val
   }
}


/*  uint Color - Get Set
    
*/
property uint vFontDialog.Color() 
{
   return .pColor
}

property vFontDialog.Color( uint val )
{
   if .pColor != val
   {
      .pColor = val
   }
}

/*     */
method uint vFontDialog.Show( )
{   
   CHOOSEFONT chf
   LOGFONT    tmplogfont
   
   tmplogfont = .LogFont
   
   chf.lStructSize = sizeof( CHOOSEFONT )
   chf.Flags = .pDevice | $CF_INITTOLOGFONTSTRUCT
   if .pEffects : chf.Flags |= $CF_EFFECTS
   chf.nSizeMin = .pSizeMin
   chf.nSizeMax = .pSizeMax
   chf.lpLogFont = &tmplogfont   
   chf.hwndOwner = .GetActiveHWND()
   chf.rgbColors = .pColor
   if ChooseFont( chf )
   {  
      .LogFont = tmplogfont
      .pColor = chf.rgbColors
      return 1
   }   
   return 0
}
 
/*------------------------------------------------------------------------------
   Registration
*/
method vOpenSaveDialog vOpenSaveDialog.init( )
{
   this.pTypeId = vOpenSaveDialog   
   return this 
}

method vSelectDir vSelectDir.init( )
{
   this.pTypeId = vSelectDir 
   this.pCanCreate = 1  
   return this 
}

method vColorDialog vColorDialog.init( )
{ 
   this.pTypeId = vColorDialog     
   return this 
}

method vFontDialog vFontDialog.init( )
{ 
   this.pTypeId = vFontDialog  
   .pDevice = $fddScreen  
   .pEffects = 1
   return this 
}

func init_vOpenSaveDialog <entry>()
{
   regcomp( vOpenSaveDialog, "vOpenSaveDialog", vComp, $vComp_last,      
      %{ %{$mLangChanged,  vOpenSaveDialog_mLangChanged } },
      0->collection )

   regcomp( vSelectDir, "vSelectDir", vComp, $vComp_last,      
      0->collection,
      0->collection )
      
   regcomp( vColorDialog, "vColorDialog", vComp, $vComp_last,      
      0->collection,
      0->collection )
                                    
   regcomp( vFontDialog, "vFontDialog", vComp, $vComp_last,      
      0->collection,
      0->collection )                                    
   
   //CoInitializeEx(0,0) 
   AddrBrowseCallbackProc = callback( &BrowseCallbackProc, 4 )
             
ifdef $DESIGNING {
   
   cm.AddComp( vOpenSaveDialog, 1, "Windows", "dialogs" )   
   
   cm.AddProps( vOpenSaveDialog, %{
"DefExt",      ustr, 0,
"FileName",    ustr, 0,
"InitialDir",  ustr, 0,
"FilterIndex", uint, 0,
"FiltersText", ustr, 0,
"TitleOpen"  , ustr, 0,
"TitleSave"  , ustr, 0,
"MultiSelect", uint, 0
   })
   
    cm.AddComp( vSelectDir, 1, "Windows", "dialogs" )   
   
   cm.AddProps( vSelectDir, %{
"Title",     ustr, 0,
"Dir",       ustr, 0,
"CanCreate", uint, 0,
"ShowEdit",  uint, 0
   })
   
   cm.AddComp( vColorDialog, 1, "Windows", "dialogs" )
   cm.AddProps( vColorDialog, %{
"Color",     uint, 0,
"AnyColor",  uint, 0,
"SolidColor",uint, 0,
"FullOpen",  uint, 0,
"PreventFullOpen", uint, 0
   })
   
   cm.AddComp( vFontDialog, 1, "Windows", "dialogs" )
   cm.AddProps( vFontDialog, %{
"SizeMin",     uint, 0,
"SizeMax",  uint, 0,
"Effects",uint, 0,
"Color",  uint, 0
   })       
}

         
                                                                                                  
}